/*
 *			PARSECALC.Y
 *
 * This is the yacc version of the parser yylex() for docalc
 *
 */

yylex()
{
	int c;

	while ((c = getchar()) == ' ') ;	/* skip blanks */

	if (islower(c)) {
		yylval = c - 'a';
		return(LETTER);
	}

	if (isdigit(c)) {
		yylval = c - '0';
		return(DIGIT);
	}

	return(c);
}
