%%
	int comment, lineno;
	comment = 0;
	lineno = 1;
"/*"	{
	if (comment) fprintf(stderr,
		" >>>>>>>> line %d: Nested comment <<<<<<<<<<\n",lineno);
	printf("%s", yytext);
	comment = 1;
	}

"*/"	{
	if (!comment) fprintf(stderr,
		" >>>>> line %d: Extra comment <<<<<<\n",lineno);
	printf("%s",yytext);
	comment = 0;
	}
\n	{
	lineno++;
	printf("%s",yytext);
}
